#
# Conditional build:
%bcond_without	dist_kernel	# allow non-distribution kernel
%bcond_without	kernel		# don't build kernel modules
%bcond_without	userspace	# don't build userspace programs
%bcond_with	verbose		# verbose build (V=1)
#
%if %{without kernel}
%undefine	with_dist_kernel
%endif

%define		rel	18
%define		pname	linux-fusion
Summary:	Fusion and One Linux kernel modules
Summary(pl.UTF-8):	Moduły Fusion i One dla jądra Linuksa
Name:		%{pname}%{_alt_kernel}
Version:	9.0.0
Release:	%{rel}
License:	GPL v2+
Group:		Base/Kernel
Source0:	http://www.directfb.org/downloads/Core/linux-fusion/%{pname}-%{version}.tar.gz
# Source0-md5:	4199617ed8ba205da52fedfb862e4507
URL:		http://www.directfb.org/
%if %{with kernel}
%{?with_dist_kernel:BuildRequires:	kernel-module-build >= 3:2.6.20.2}
BuildRequires:	rpmbuild(macros) >= 1.379
%endif
BuildRequires:	sed >= 4.0
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Fusion and One Linux kernel modules.

%description -l pl.UTF-8
Moduły Fusion i One dla jądra Linuksa.

%package devel
Summary:	Header file for Fusion device
Summary(pl.UTF-8):	Plik nagłówkowy dla urządzenia Fusion
Group:		Development/Libraries
Requires:	linux-libc-headers

%description devel
Header file for Fusion device.

%description devel -l pl.UTF-8
Plik nagłówkowy dla urządzenia Fusion.

%package -n linux-one-devel
Summary:	Header file for One IPC device
Summary(pl.UTF-8):	Plik nagłówkowy dla urządzenia IPC One
Group:		Development/Libraries
Requires:	linux-libc-headers

%description -n linux-one-devel
Header file for One IPC device.

Linux One is the new IPC API used by Coma.

%description -n linux-one-devel -l pl.UTF-8
Plik nagłówkowy dla urządzenia IPC One.

Linux One to nowe API IPC wykorzystywane przez Comę.

%package -n kernel%{_alt_kernel}-char-fusion
Summary:	Fusion module for Linux kernel
Summary(pl.UTF-8):	Moduł Fusion dla jądra Linuksa
Release:	%{rel}@%{_kernel_ver_str}
Group:		Base/Kernel
Requires(post,postun):	/sbin/depmod
%if %{with dist_kernel}
%requires_releq_kernel
Requires(postun):	%releq_kernel
%endif

%description -n kernel%{_alt_kernel}-char-fusion
Fusion module for Linux kernel.

%description -n kernel%{_alt_kernel}-char-fusion -l pl.UTF-8
Moduł Fusion dla jądra Linuksa.

%package -n kernel%{_alt_kernel}-misc-one
Summary:	One IPC module for Linux kernel
Summary(pl.UTF-8):	Moduł IPC One dla jądra Linuksa
Release:	%{rel}@%{_kernel_ver_str}
Group:		Base/Kernel
Requires(post,postun):	/sbin/depmod
%if %{with dist_kernel}
%requires_releq_kernel
Requires(postun):	%releq_kernel
%endif

%description -n kernel%{_alt_kernel}-misc-one
One IPC module for Linux kernel.

Linux One is the new IPC API used by Coma.

%description -n kernel%{_alt_kernel}-misc-one -l pl.UTF-8
Moduł IPC One dla jądra Linuksa.

Linux One to nowe API IPC wykorzystywane przez Comę.

%prep
%setup -q -n %{pname}-%{version}

%{__sed} -i -e 's/^obj-[^ ]*/obj-m/' linux/drivers/char/fusion/Makefile-2.6
%{__sed} -i -e 's/^obj-[^ ]*/obj-m/' one/Makefile-2.6
echo "EXTRA_CFLAGS = -I`pwd`/linux/include -I`pwd`/linux/drivers/char/fusion -I`pwd`/linux/drivers/char/fusion/single" >> linux/drivers/char/fusion/Makefile-2.6
echo "EXTRA_CFLAGS = -I`pwd`/include -I`pwd`/one/single" >> one/Makefile-2.6

%build
%if %{with kernel}
cd linux/drivers/char/fusion
ln -sf Makefile-2.6 Makefile
# NOTE: build_kernel_modules (as of rpm macros 1.649) doesn't allow line breaking
%build_kernel_modules -m fusion FUSIONCORE=single
cd ../../../../one
ln -sf Makefile-2.6 Makefile
%build_kernel_modules -m linux-one ONECORE=single
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with userspace}
install -d $RPM_BUILD_ROOT%{_includedir}/linux
install linux/include/linux/fusion.h $RPM_BUILD_ROOT%{_includedir}/linux
install include/linux/one.h $RPM_BUILD_ROOT%{_includedir}/linux
%endif

%if %{with kernel}
cd linux/drivers/char/fusion
%install_kernel_modules -m fusion -d kernel/drivers/char
cd ../../../../one
%install_kernel_modules -m linux-one -d misc
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	-n kernel%{_alt_kernel}-char-fusion
%depmod %{_kernel_ver}

%postun	-n kernel%{_alt_kernel}-char-fusion
%depmod %{_kernel_ver}

%post	-n kernel%{_alt_kernel}-misc-one
%depmod %{_kernel_ver}

%postun	-n kernel%{_alt_kernel}-misc-one
%depmod %{_kernel_ver}

%if %{with userspace}
%files devel
%defattr(644,root,root,755)
%doc ChangeLog README TODO
%{_includedir}/linux/fusion.h

%files -n linux-one-devel
%defattr(644,root,root,755)
%doc README.linux-one TODO.linux-one
%{_includedir}/linux/one.h
%endif

%if %{with kernel}
%files -n kernel%{_alt_kernel}-char-fusion
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}/kernel/drivers/char/fusion.ko*

%files -n kernel%{_alt_kernel}-misc-one
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}/misc/linux-one.ko*
%endif
%changelog
* Thu May 02 2013 Jan Rękorajski <baggins@pld-linux.org> 31e83a4
- release 18 (by relup.sh)

* Thu Apr 18 2013 Jan Rękorajski <baggins@pld-linux.org> 41de9cd
- rebuild for kernel-3.7.10-7
- release 17 (by relup.sh)

* Sun Apr 14 2013 Jan Rękorajski <baggins@pld-linux.org> 7a9e0ca
- rebuild for kernel-3.7.10-6
- release 16 (by relup.sh)

* Sat Apr 13 2013 Jan Rękorajski <baggins@pld-linux.org> 6837a0e
- rebuild for kernel-3.7.10-4
- release 15 (by relup.sh)

* Fri Mar 15 2013 Jan Rękorajski <baggins@pld-linux.org> a1c1dc6
- rebuild for kernel-3.7.10-3
- release 14 (by relup.sh)

* Thu Mar 07 2013 Jan Rękorajski <baggins@pld-linux.org> 3e2184f
- rebuild for kernel-3.7.10-3
- release 13 (by relup.sh)

* Sun Mar 03 2013 Jan Rękorajski <baggins@pld-linux.org> d7b7408
- rebuild for kernel-3.7.10-2
- release 12 (by relup.sh)

* Wed Feb 27 2013 Jan Rękorajski <baggins@pld-linux.org> 98f16b0
- rebuild for kernel-3.7.10-1
- release 11 (by relup.sh)

* Tue Feb 26 2013 Jan Rękorajski <baggins@pld-linux.org> 552cf91
- rebuild for kernel-3.7.9-2
- release 10 (by relup.sh)

* Sun Feb 17 2013 Jan Rękorajski <baggins@pld-linux.org> 584af66
- rebuild for kernel-3.7.9-1
- release 9 (by relup.sh)

* Fri Feb 15 2013 Jan Rękorajski <baggins@pld-linux.org> f0f4443
- rebuild for kernel-3.7.8-1
- release 8 (by relup.sh)

* Tue Feb 12 2013 Jan Rękorajski <baggins@pld-linux.org> 2ef27cd
- rebuild for kernel-3.7.7-1
- release 7 (by relup.sh)

* Mon Feb 04 2013 Jan Rękorajski <baggins@pld-linux.org> 4c738ba
- rebuild for kernel-3.7.6-1
- release 6 (by relup.sh)

* Mon Jan 28 2013 Jan Rękorajski <baggins@pld-linux.org> ae9caa9
- rebuild for kernel-3.7.5-1
- release 5 (by relup.sh)

* Tue Jan 22 2013 Jan Rękorajski <baggins@pld-linux.org> 3fc4593
- rel 4

* Tue Jan 22 2013 Jan Rękorajski <baggins@pld-linux.org> 6a322d1
- fix build dir for alt_kernel

* Mon Jan 21 2013 Jan Rękorajski <baggins@pld-linux.org> 21b4799
- rel 3

* Mon Jan 21 2013 Jan Rękorajski <baggins@pld-linux.org> 412dbd1
- fix source0

* Mon Jan 21 2013 Jan Rękorajski <baggins@pld-linux.org> fb70470
- rel 2
- fix kernel packages

* Sat Jan 19 2013 Jakub Bogusz <qboosh@pld-linux.org> 6edb6a1
- updated to 9.0.0
- build also One (linux-one-devel, kernel-one)

